(*
* Code by aha / Holograms
* 2008.01.31
*)
unit ConfigForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls;

type
	PDialogParam = ^DialogParam;
	DialogParam = record
		width 	: Integer;
		height	: Integer;
		hz 			: Integer;
		fs			: Boolean;
		bits		: Integer;
		vsync		: Boolean;
		name		: PChar;
	end;

type
	PDialogParamMain = ^DialogParamMain;
	DialogParamMain = record
		width 	: Integer;
		height	: Integer;
		hz 			: Integer;
		bits		: Integer;
	end;
  
type
  TFormConfig = class(TForm)
    Image: TImage;
    ListBox: TListBox;
    CheckBoxVsync: TCheckBox;
    RadioButtonWindow: TRadioButton;
    RadioButtonFullScreen: TRadioButton;
    ButtonCancel: TButton;
    ButtonStart: TButton;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ListBoxKeyPress(Sender: TObject; var Key: Char);
    procedure RadioButtonFullScreenKeyPress(Sender: TObject;
      var Key: Char);
    procedure RadioButtonWindowKeyPress(Sender: TObject; var Key: Char);
    procedure CheckBoxVsyncKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonCancelKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonStartKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonCancelClick(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    procedure Update;
    procedure KeyEvent(Key: Char);
    procedure Enter(Key: Char);
  public
    { Public declarations }
    p : PDialogParam;
    t : TList;
  end;

var
  FormConfig: TFormConfig;

implementation

{$R *.dfm}

procedure TFormConfig.KeyEvent(Key: Char);
begin
	if Key = #27 then
  	ModalResult := mrCancel
  else if Key = #13 then
		Update;
end;

procedure TFormConfig.Update;
var pm : PDialogParamMain;
begin
	if not Assigned(p) then 
  	ModalResult := mrCancel
	else 
  begin  
		p^.fs 			:= RadioButtonFullScreen.Checked;
		p^.vsync  	:= CheckBoxVSync.Checked;
		pm 					:= PDialogParamMain(t.Items[ListBox.ItemIndex]);
		p^.width		:= pm^.width;
		p^.height		:= pm^.height;
		p^.bits			:= pm^.bits;
		p^.hz				:= pm^.hz;
		ModalResult := mrOk;
  end;
end;

procedure TFormConfig.Enter(Key: Char);
begin
;
end;

procedure TFormConfig.FormKeyPress(Sender: TObject; var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.ListBoxKeyPress(Sender: TObject; var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.RadioButtonFullScreenKeyPress(Sender: TObject;
  var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.RadioButtonWindowKeyPress(Sender: TObject;
  var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.CheckBoxVsyncKeyPress(Sender: TObject;
  var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.ButtonCancelKeyPress(Sender: TObject; var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.ButtonStartKeyPress(Sender: TObject; var Key: Char);
begin
	KeyEvent(Key);
end;

procedure TFormConfig.ButtonCancelClick(Sender: TObject);
begin
	ModalResult := mrCancel;
end;

procedure TFormConfig.ButtonStartClick(Sender: TObject);
begin
	Update;
end;

procedure TFormConfig.FormShow(Sender: TObject);
var 
	dm	: DEVMODE;
  i		: Integer;
  res	: Longint;
  item: Integer;
  sel : Integer;
  pm	: PDialogParamMain;
begin
	if not Assigned(p) then Exit;
	Caption												:= p^.name;
	RadioButtonFullScreen.Checked := p^.fs;
	RadioButtonWindow.Checked			:= not p^.fs;
	CheckBoxVSync.Checked					:= p^.vsync;  
	i 	:= 0;
	sel := 0;
	t		:= TList.Create;
	while ( EnumDisplaySettings(nil,i, dm ) ) do
	begin
		res := ChangeDisplaySettings ( dm, CDS_TEST );
		if ( res = DISP_CHANGE_SUCCESSFUL ) and 
       ( dm.dmBitsPerPel <> 8 )					and 
       ( dm.dmBitsPerPel <> 4 )					then
		begin
    	item := ListBox.Items.Add(
        PChar(IntToStr(dm.dmPelsWidth)) + ' x ' +
				PChar(IntToStr(dm.dmPelsHeight)) + ' ' +
				PChar(IntToStr(dm.dmBitsPerPel)) + ' Bit ' +
				PChar(IntToStr(dm.dmDisplayFrequency)) + 'Hz'
      );
      New(pm);
      pm^.width 	:= dm.dmPelsWidth;
      pm^.height  := dm.dmPelsHeight;
      pm^.bits		:= dm.dmBitsPerPel;
      pm^.hz			:= dm.dmDisplayFrequency;
      t.Add(pm);
      if
      	( dm.dmPelsWidth				= p^.width	) and 
      	( dm.dmPelsHeight 			= p^.height	) and
        ( dm.dmBitsPerPel				= p^.bits		) and
        ( dm.dmDisplayFrequency	= p^.hz			) then
        sel := item;
    end;
		inc(i);
	end;
  ListBox.Selected[sel] := true;   
end;

end.
